<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>conqueue: src/conqueue.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">conqueue
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">conqueue.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;conqueue.h&quot;</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno"><a class="line" href="classmutils_1_1conqueue.html#a8f0b24fc2bf5a4e84db449a9c4fc65b2">    3</a></span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <a class="code" href="classmutils_1_1conqueue.html#a8f0b24fc2bf5a4e84db449a9c4fc65b2">mutils::conqueue&lt;T&gt;::~conqueue</a>() { _container.clear(); }</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;</div><div class="line"><a name="l00005"></a><span class="lineno"><a class="line" href="classmutils_1_1conqueue.html#aebad37af104f9b7bafbd02325795ee81">    5</a></span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keywordtype">void</span> <a class="code" href="classmutils_1_1conqueue.html#aebad37af104f9b7bafbd02325795ee81">mutils::conqueue&lt;T&gt;::enqueue</a>(T&amp;&amp; el)</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;{</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;  std::lock_guard&lt;std::mutex&gt; lk(_mx);</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;  _container.emplace_back(std::forward&lt;T&gt;(el));</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;  _cv.notify_one();</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;}</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classmutils_1_1conqueue.html#ae5e6b297131a997b8e6a37b1ae9b6f52">   12</a></span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; T <a class="code" href="classmutils_1_1conqueue.html#ae5e6b297131a997b8e6a37b1ae9b6f52">mutils::conqueue&lt;T&gt;::dequeue</a>()</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;  std::lock_guard&lt;std::mutex&gt; lk(_mx);</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;  <span class="keywordflow">if</span> (_container.begin() == _container.end()) {</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;Queue is empty&quot;</span>);</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;  }</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;  <span class="keyword">auto</span> it = _container.begin();</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;  _container.erase(it);</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;  <span class="keywordflow">return</span> *it;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;}</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="classmutils_1_1conqueue.html#a389275c51e7eb3f367c2ee8ac70a2615">   23</a></span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; T <a class="code" href="classmutils_1_1conqueue.html#a389275c51e7eb3f367c2ee8ac70a2615">mutils::conqueue&lt;T&gt;::dequeueOrBlock</a>()</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;{</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  std::unique_lock&lt;std::mutex&gt; uk(_mx);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <span class="keywordflow">if</span> (_container.begin() == _container.end()) {</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    _cv.wait(uk, [<span class="keyword">this</span>]() { <span class="keywordflow">return</span> _container.begin() != _container.end(); });</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  }</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;  <span class="keyword">auto</span> it = _container.begin();</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  _container.erase(it);</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;  <span class="keywordflow">return</span> *it;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;}</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classmutils_1_1conqueue.html#a1f77547ec1b71152b6b5657259b704fc">   35</a></span>&#160;T <a class="code" href="classmutils_1_1conqueue.html#a1f77547ec1b71152b6b5657259b704fc">mutils::conqueue&lt;T&gt;::dequeueOrBlockFor</a>(</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    std::chrono::system_clock::duration duration)</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;{</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;  std::unique_lock&lt;std::mutex&gt; uk(_mx);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;  <span class="keywordflow">if</span> (_container.begin() == _container.end()) {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    _cv.wait_for(uk, duration);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  }</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  <span class="keywordflow">if</span> (_container.begin() == _container.end()) {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;Time out on an empty queue.&quot;</span>);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  }</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <span class="keyword">auto</span> it = _container.begin();</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;  _container.erase(it);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  <span class="keywordflow">return</span> *it;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;}</div><div class="ttc" id="classmutils_1_1conqueue_html_a389275c51e7eb3f367c2ee8ac70a2615"><div class="ttname"><a href="classmutils_1_1conqueue.html#a389275c51e7eb3f367c2ee8ac70a2615">mutils::conqueue::dequeueOrBlock</a></div><div class="ttdeci">T dequeueOrBlock()</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:23</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_a8f0b24fc2bf5a4e84db449a9c4fc65b2"><div class="ttname"><a href="classmutils_1_1conqueue.html#a8f0b24fc2bf5a4e84db449a9c4fc65b2">mutils::conqueue::~conqueue</a></div><div class="ttdeci">~conqueue()</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:3</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_a1f77547ec1b71152b6b5657259b704fc"><div class="ttname"><a href="classmutils_1_1conqueue.html#a1f77547ec1b71152b6b5657259b704fc">mutils::conqueue::dequeueOrBlockFor</a></div><div class="ttdeci">T dequeueOrBlockFor(std::chrono::system_clock::duration)</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:35</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_aebad37af104f9b7bafbd02325795ee81"><div class="ttname"><a href="classmutils_1_1conqueue.html#aebad37af104f9b7bafbd02325795ee81">mutils::conqueue::enqueue</a></div><div class="ttdeci">void enqueue(T &amp;&amp;el)</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:5</div></div>
<div class="ttc" id="classmutils_1_1conqueue_html_ae5e6b297131a997b8e6a37b1ae9b6f52"><div class="ttname"><a href="classmutils_1_1conqueue.html#ae5e6b297131a997b8e6a37b1ae9b6f52">mutils::conqueue::dequeue</a></div><div class="ttdeci">T dequeue()</div><div class="ttdef"><b>Definition:</b> conqueue.hpp:12</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
